unit MainFrm;

interface

uses
  Qt,SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QComCtrls, QExtCtrls, QButtons, cad, QMenus,
  QImgList, QActnList;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    ScrollBox1: TScrollBox;
    sbtnLine: TSpeedButton;
    sbtnSelecting: TSpeedButton;
    sbtnRuleLine: TSpeedButton;
    sbtnRotateSelecting: TSpeedButton;
    sbtnEllipse: TSpeedButton;
    sbtnLinkLine: TSpeedButton;
    sbtnRectangle: TSpeedButton;
    LineLinkLine: TSpeedButton;
    sbtnPolyLine: TSpeedButton;
    sbtnPolygon: TSpeedButton;
    sbtnElliArc: TSpeedButton;
    sbtnZoomIn: TSpeedButton;
    sbtnPolyBezier: TSpeedButton;
    sbtnZoomOut: TSpeedButton;
    sbtnText: TSpeedButton;
    sbtnDrag: TSpeedButton;
    sbtnImage: TSpeedButton;
    sbtnAbout: TSpeedButton;
    cmbZoom: TComboBox;
    lblLabelXY: TLabel;
    lblLabelValue: TLabel;
    MainMenu1: TMainMenu;
    ToolBar1: TToolBar;
    miFile: TMenuItem;
    miNew: TMenuItem;
    miOpen: TMenuItem;
    miOpenLib: TMenuItem;
    miSaveAs: TMenuItem;
    N1: TMenuItem;
    miExport: TMenuItem;
    miImportTCAD: TMenuItem;
    miImportAutoCAD: TMenuItem;
    N2: TMenuItem;
    miPageSetup: TMenuItem;
    miPrintSetup: TMenuItem;
    N3: TMenuItem;
    miPrint: TMenuItem;
    N4: TMenuItem;
    miExit: TMenuItem;
    miEdit: TMenuItem;
    miCopy: TMenuItem;
    miCut: TMenuItem;
    miPaste: TMenuItem;
    miUndo: TMenuItem;
    miDelete: TMenuItem;
    N5: TMenuItem;
    miGroupShape: TMenuItem;
    miUngroupShape: TMenuItem;
    N6: TMenuItem;
    miSendToBack: TMenuItem;
    miBringtofront: TMenuItem;
    N7: TMenuItem;
    miLock: TMenuItem;
    miUnlock: TMenuItem;
    N8: TMenuItem;
    miFlipVertical: TMenuItem;
    miFilpHorizontal: TMenuItem;
    miAlign: TMenuItem;
    AlignLeft1: TMenuItem;
    AlignRight1: TMenuItem;
    AlignTop1: TMenuItem;
    AlignBottom1: TMenuItem;
    AlignHorizontalCenter1: TMenuItem;
    AlignVerticalCenter1: TMenuItem;
    miCodeDrawing: TMenuItem;
    miSelecting: TMenuItem;
    miLine: TMenuItem;
    miRuleLine: TMenuItem;
    miArc: TMenuItem;
    miPolyLine: TMenuItem;
    miPolygon: TMenuItem;
    miPolyBezier: TMenuItem;
    miRectangle: TMenuItem;
    miEllipse: TMenuItem;
    miText: TMenuItem;
    miCodeSelecting: TMenuItem;
    miOption: TMenuItem;
    miSelectShape: TMenuItem;
    miSelectMoreShapes: TMenuItem;
    miDeSelectShape: TMenuItem;
    miSelectAllShapes: TMenuItem;
    miToggleGrid: TMenuItem;
    miLineGrind: TMenuItem;
    miPixelGrid: TMenuItem;
    N9: TMenuItem;
    miSnapToGrid: TMenuItem;
    miSnapToShape: TMenuItem;
    miZoom: TMenuItem;
    miZoomin: TMenuItem;
    miZoomout: TMenuItem;
    miNicefit: TMenuItem;
    miWindow: TMenuItem;
    miInspector: TMenuItem;
    miLayerManager: TMenuItem;
    miLibrary: TMenuItem;
    miHelp: TMenuItem;
    miAbout: TMenuItem;
    miVisitOurSite: TMenuItem;
    miSendMailToUs: TMenuItem;
    miBuyNow: TMenuItem;
    miShowTCADVersion: TMenuItem;
    tbtnNew: TToolButton;
    tbtnOpen: TToolButton;
    tbtnOpenLib: TToolButton;
    tbtnSave: TToolButton;
    tbtnPageSetup: TToolButton;
    tbtnPrintSetup: TToolButton;
    tbtnPreview: TToolButton;
    ToolButton7: TToolButton;
    tbtnCopy: TToolButton;
    tbtnCut: TToolButton;
    tbtnPaste: TToolButton;
    tbtnUndo: TToolButton;
    tbtnDelete: TToolButton;
    tbtnLock: TToolButton;
    tbtnUnlock: TToolButton;
    ToolButton15: TToolButton;
    tbtnGroup: TToolButton;
    tbtnUngroup: TToolButton;
    tbtnSendToBack: TToolButton;
    tbtnBringToFront: TToolButton;
    tbtnSendToBackByStep: TToolButton;
    tbtnBringToFrontByStep: TToolButton;
    ToolButton22: TToolButton;
    tbtnAlignTop: TToolButton;
    tbtnAlignBottom: TToolButton;
    tbtnAlignLeft: TToolButton;
    tbtnAlignRight: TToolButton;
    tbtnAlignVerticalCenter: TToolButton;
    tbtnAlignHorizontalCenter: TToolButton;
    ToolButton29: TToolButton;
    tbtnFlipVertical: TToolButton;
    tbtnFlipHorizontal: TToolButton;
    ToolButton32: TToolButton;
    tbtnZoomin: TToolButton;
    tbtnZoomout: TToolButton;
    ToolButton35: TToolButton;
    tbtnToggleGrid: TToolButton;
    tbtnLineGrid: TToolButton;
    tbtnPixelGrid: TToolButton;
    tbtnSnapToGrid: TToolButton;
    tbtnSnapToShape: TToolButton;
    ImageList1: TImageList;
    ActionList1: TActionList;
    About: TAction;
    AlignLeft: TAction;
    AlignRight: TAction;
    AlignTop: TAction;
    AlignBottom: TAction;
    AlignHorizontalCenter: TAction;
    AlignVerticalCenter: TAction;
    ToggleGrid: TAction;
    LineGrid: TAction;
    PixelGrid: TAction;
    SnapToGrid: TAction;
    SnapToShape: TAction;
    Zoomin: TAction;
    Zoomout: TAction;
    Nicefit: TAction;
    VisitOurSite: TAction;
    SendMailToUs: TAction;
    ByNow: TAction;
    ShowTCADVersion: TAction;
    ACopy: TAction;
    Cut: TAction;
    Paste: TAction;
    Undo: TAction;
    Delete: TAction;
    GroupShape: TAction;
    UngroupShape: TAction;
    SendToBack: TAction;
    BringToFront: TAction;
    Lock: TAction;
    Unlock: TAction;
    FlipVertical: TAction;
    FlipHorizontal: TAction;
    SendToBackByStep: TAction;
    BringToFrontByStep: TAction;
    SelectShape: TAction;
    SelectMoreShapes: TAction;
    DeSelectShape: TAction;
    SelectAllShapes: TAction;
    ImageFileOpen: TOpenDialog;
    Inspector: TAction;
    LayerManager: TAction;
    LibraryManager: TAction;
    Selecting: TAction;
    Line: TAction;
    RuleLine: TAction;
    Arc: TAction;
    PolyLine: TAction;
    Polygon: TAction;
    PolyBezier: TAction;
    Rectangle: TAction;
    Ellipse: TAction;
    Text: TAction;
    New: TAction;
    Open: TAction;
    OpenLib: TAction;
    SaveAs: TAction;
    Bitmap: TAction;
    ImportTCADFile: TAction;
    ImportAutoCADFile: TAction;
    PageSetup: TAction;
    PrintSetup: TAction;
    Print: TAction;
    AExit: TAction;
    miBitmap: TMenuItem;
    miWMF: TMenuItem;
    miJPEG: TMenuItem;
    miDXF: TMenuItem;
    WMF: TAction;
    JPEG: TAction;
    DXF: TAction;
    Splitter1: TSplitter;
    Panel2: TPanel;
    PageControl1: TPageControl;
    tsLayer: TTabSheet;
    tsLibrary: TTabSheet;
    Panel3: TPanel;
    tvLayer: TTreeView;
    sbtnLayerNew: TSpeedButton;
    sbtnLayerDelete: TSpeedButton;
    sbtnLayerHideVisible: TSpeedButton;
    sbtnLayerRefresh: TSpeedButton;
    ImageList2: TImageList;
    PageControl2: TPageControl;
    FileSaveAs: TSaveDialog;
    FileOpen: TOpenDialog;
    PopupMenu1: TPopupMenu;
    miClose: TMenuItem;
    FileExport: TSaveDialog;
    tsInspector: TTabSheet;
    pcShapesParameter: TPageControl;
    tsShapeParameter: TTabSheet;
    Panel4: TPanel;
    ColorDialog1: TColorDialog;
    PRuleLine: TPanel;
    PLinkLine: TPanel;
    lblTickStyle: TLabel;
    cmbTickStyle: TComboBox;
    lblLinkLineDrawStyle: TLabel;
    cmbLinkLineDrawStyle: TComboBox;
    PLine: TPanel;
    lblArrowStyle: TLabel;
    cmbArrowStyle: TComboBox;
    edtArrowOffset: TEdit;
    lblArrowOffset: TLabel;
    lblArrowLength: TLabel;
    edtArrowLength: TEdit;
    edtArrowAngle: TEdit;
    lblArrowAngle: TLabel;
    gbPen: TGroupBox;
    lblPenColor: TLabel;
    PPenColor: TPanel;
    lblPenWidth: TLabel;
    sePenWidth: TSpinEdit;
    lblPenSytle: TLabel;
    cmbPenStyle: TComboBox;
    gbBrush: TGroupBox;
    lblBrushColor: TLabel;
    lblBrushStyle: TLabel;
    PBrushColor: TPanel;
    cmbBrushStyle: TComboBox;
    gbAngle: TGroupBox;
    edtAngle: TEdit;
    MyCAD1: TMyCAD;
    PImage: TPanel;
    lblBitmap: TLabel;
    lblBorder: TLabel;
    btnSetBitmap: TButton;
    cbBorder: TCheckBox;
    PText: TPanel;
    lblFontSize: TLabel;
    edtFontSize: TEdit;
    PElliArc: TPanel;
    cmbArcStyle: TComboBox;
    lblArcStyle: TLabel;
    cmbArcMode: TComboBox;
    lblArcMode: TLabel;
    lblLines: TLabel;
    Memo1: TMemo;
    lblHAlignment: TLabel;
    lblVAlignment: TLabel;
    lblWordWrap: TLabel;
    cbHAlignment: TComboBox;
    cbVAlignment: TComboBox;
    cbWordWrap: TComboBox;
    btnUpdate: TButton;
    btnClear: TButton;
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure cmbZoomChange(Sender: TObject);
    procedure sbtnLineClick(Sender: TObject);
    procedure MyCAD1ActionToolToSelecting;
    procedure sbtnRuleLineClick(Sender: TObject);
    procedure sbtnRectangleClick(Sender: TObject);
    procedure sbtnPolyLineClick(Sender: TObject);
    procedure sbtnPolygonClick(Sender: TObject);
    procedure sbtnEllipseClick(Sender: TObject);
    procedure AboutExecute(Sender: TObject);
    procedure sbtnElliArcClick(Sender: TObject);
    procedure sbtnPolyBezierClick(Sender: TObject);
    procedure sbtnImageClick(Sender: TObject);
    procedure sbtnRotateSelectingClick(Sender: TObject);
    procedure sbtnLinkLineClick(Sender: TObject);
    procedure LineLinkLineClick(Sender: TObject);
    procedure AlignLeftExecute(Sender: TObject);
    procedure AlignRightExecute(Sender: TObject);
    procedure AlignTopExecute(Sender: TObject);
    procedure AlignBottomExecute(Sender: TObject);
    procedure AlignHorizontalCenterExecute(Sender: TObject);
    procedure AlignVerticalCenterExecute(Sender: TObject);
    procedure ToggleGridExecute(Sender: TObject);
    procedure LineGridExecute(Sender: TObject);
    procedure PixelGridExecute(Sender: TObject);
    procedure SnapToGridExecute(Sender: TObject);
    procedure SnapToShapeExecute(Sender: TObject);
    procedure ZoominExecute(Sender: TObject);
    procedure ZoomoutExecute(Sender: TObject);
    procedure NicefitExecute(Sender: TObject);
    procedure ShowTCADVersionExecute(Sender: TObject);
    procedure ACopyExecute(Sender: TObject);
    procedure CutExecute(Sender: TObject);
    procedure PasteExecute(Sender: TObject);
    procedure DeleteExecute(Sender: TObject);
    procedure UndoExecute(Sender: TObject);
    procedure GroupShapeExecute(Sender: TObject);
    procedure UngroupShapeExecute(Sender: TObject);
    procedure SendToBackExecute(Sender: TObject);
    procedure BringToFrontExecute(Sender: TObject);
    procedure LockExecute(Sender: TObject);
    procedure UnlockExecute(Sender: TObject);
    procedure SendToBackByStepExecute(Sender: TObject);
    procedure BringToFrontByStepExecute(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SelectShapeExecute(Sender: TObject);
    procedure SelectMoreShapesExecute(Sender: TObject);
    procedure DeSelectShapeExecute(Sender: TObject);
    procedure SelectAllShapesExecute(Sender: TObject);
    procedure MyCAD1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MyCAD1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure MyCAD1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure sbtnSelectingClick(Sender: TObject);
    procedure MyCAD1ShapeSelected(LastSelectedShape,
      SelectedShape: TMyShape);
    procedure MyCAD1ShapeAdded(var AShape: TMyShape; ShapeCount: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure AExitExecute(Sender: TObject);
    procedure PageSetupExecute(Sender: TObject);
    procedure PrintExecute(Sender: TObject);
    procedure Splitter1Moved(Sender: TObject);
    procedure sbtnLayerRefreshClick(Sender: TObject);
    procedure sbtnLayerNewClick(Sender: TObject);
    procedure sbtnLayerDeleteClick(Sender: TObject);
    procedure sbtnLayerHideVisibleClick(Sender: TObject);
    procedure tvLayerEdited(Sender: TObject; Node: TTreeNode;
      var S: WideString);
    procedure tvLayerChange(Sender: TObject; Node: TTreeNode);
    procedure NewExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OpenExecute(Sender: TObject);
    procedure OpenLibExecute(Sender: TObject);
    procedure ImportTCADFileExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure miCloseClick(Sender: TObject);
    procedure MyCAD1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure MyCAD1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure LayerManagerExecute(Sender: TObject);
    procedure LibraryManagerExecute(Sender: TObject);
    procedure BitmapExecute(Sender: TObject);
    procedure SelectingExecute(Sender: TObject);
    procedure LineExecute(Sender: TObject);
    procedure RuleLineExecute(Sender: TObject);
    procedure ArcExecute(Sender: TObject);
    procedure PolyLineExecute(Sender: TObject);
    procedure PolygonExecute(Sender: TObject);
    procedure PolyBezierExecute(Sender: TObject);
    procedure RectangleExecute(Sender: TObject);
    procedure EllipseExecute(Sender: TObject);
    procedure TextExecute(Sender: TObject);
    procedure sbtnTextClick(Sender: TObject);
    procedure sePenWidthChanged(Sender: TObject; NewValue: Integer);
    procedure cmbPenStyleChange(Sender: TObject);
    procedure PPenColorClick(Sender: TObject);
    procedure PBrushColorClick(Sender: TObject);
    procedure edtArrowAngleKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edtArrowLengthKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edtArrowOffsetKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cmbArrowStyleChange(Sender: TObject);
    procedure cmbBrushStyleChange(Sender: TObject);
    procedure cmbTickStyleChange(Sender: TObject);
    procedure cmbLinkLineDrawStyleChange(Sender: TObject);
    procedure cmbArcModeChange(Sender: TObject);
    procedure cmbArcStyleChange(Sender: TObject);
    procedure cbBorderClick(Sender: TObject);
    procedure btnSetBitmapClick(Sender: TObject);
    procedure InspectorExecute(Sender: TObject);
    procedure edtAngleKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MyCAD1ShapeMouseRotated(AShape: TMyShape; FromPoint,
      ToPoint: TPoint);
    procedure MyCAD1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SaveAsExecute(Sender: TObject);
    procedure edtFontSizeKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cbHAlignmentChange(Sender: TObject);
    procedure cbVAlignmentChange(Sender: TObject);
    procedure cbWordWrapChange(Sender: TObject);
    procedure btnUpdateClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
  private
    { Private declarations }
    mDown:boolean;
    mDes,mOrg:TPoint;

    EditingFileName:string;

    //Library
    ATabSheet:TTabSheet;
    AListView:TListView;

    function  SaveEditingFile:boolean;
    procedure RefreshMenu;

    //Library
    procedure TabSheetShow(Sender: TObject);

  public
    { Public declarations }
    //Library
    mLibManager:TLibManager;
    mListView:TListView;
    LibManagers:Array of TLibManager;

    procedure CenterCAD();

    //Layer
    procedure Refreshit;

    //Library
    procedure DrawListView(LibFileName:string);
    procedure LoadLib(LibFileName:String);
    procedure RemoveLibManager(id:integer);

    //Inspector
    procedure LoadCommonParameter;

  end;

var
  MainForm: TMainForm;

implementation

uses AboutFrm,SetupFrm,PreviewFrm;

{$R *.xfm}

{ TMainForm }

procedure TMainForm.CenterCAD;
begin
  MyCAD1.Left:=(ScrollBox1.Width - MyCAD1.Width) div 2;
  MyCAD1.Top:=(ScrollBox1.Height - MyCAD1.Height) div 2;
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  CenterCAD;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  sbtnAbout.Caption:='';
  cmbZoom.ItemIndex:=2;
  MyCAD1.SnapPixels:=8;
  //Self.WindowState:=wsMaximized;
  CenterCAD;

  //Layer
  Refreshit;

  //Inspector
  LoadCommonParameter;
end;

procedure TMainForm.cmbZoomChange(Sender: TObject);
begin
  with MyCAD1 do
    case cmbZoom.ItemIndex of
      0:Zoom:=0.5 ;
      1:Zoom:=0.75 ;
      2:Zoom:=1 ;
      3:Zoom:=1.1 ;
      4:Zoom:=1.3 ;
      5:Zoom:=2 ;
      6:Zoom:=4 ;
      7:Zoom:=8 ;
    end;
  CenterCAD;

end;

procedure TMainForm.sbtnLineClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=SpLine;
end;

procedure TMainForm.MyCAD1ActionToolToSelecting;
begin
  sbtnSelecting.Down:=true;
end;

procedure TMainForm.sbtnRuleLineClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=SpRuleLine;
end;

procedure TMainForm.sbtnRectangleClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=SpRectangle;
end;

procedure TMainForm.sbtnPolyLineClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=SpPolyLine;
end;

procedure TMainForm.sbtnPolygonClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=SpPolygon;
end;

procedure TMainForm.sbtnEllipseClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=SpEllipse;
end;

procedure TMainForm.AboutExecute(Sender: TObject);
begin
  AboutForm.ShowModal;
end;

procedure TMainForm.sbtnElliArcClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=SpElliArc;
end;

procedure TMainForm.sbtnPolyBezierClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=SpPolyBezier;
end;

procedure TMainForm.sbtnImageClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=SpImage;
end;

procedure TMainForm.sbtnRotateSelectingClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=SpRotateSelecting;
end;

procedure TMainForm.sbtnLinkLineClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=SpLinkLine;
end;

procedure TMainForm.LineLinkLineClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=SpLineLinkLine;
end;

procedure TMainForm.AlignLeftExecute(Sender: TObject);
begin
  MyCAD1.AlignLeft;
end;

procedure TMainForm.AlignRightExecute(Sender: TObject);
begin
  MyCAD1.AlignRight;
end;

procedure TMainForm.AlignTopExecute(Sender: TObject);
begin
  MyCAD1.AlignTop;
end;

procedure TMainForm.AlignBottomExecute(Sender: TObject);
begin
  MyCAD1.AlignBottom;
end;

procedure TMainForm.AlignHorizontalCenterExecute(Sender: TObject);
begin
  MyCAD1.AlignHorizontalCenter;
end;

procedure TMainForm.AlignVerticalCenterExecute(Sender: TObject);
begin
  MyCAD1.AlignVerticalCenter;
end;

procedure TMainForm.ToggleGridExecute(Sender: TObject);
begin
  MyCAD1.GridOperation.GridShow:=not MyCAD1.GridOperation.GridShow;
end;

procedure TMainForm.LineGridExecute(Sender: TObject);
begin
  MyCAD1.GridOperation.GridType:=gLine;
end;

procedure TMainForm.PixelGridExecute(Sender: TObject);
begin
  MyCAD1.GridOperation.GridType:=gPixel;
end;

procedure TMainForm.SnapToGridExecute(Sender: TObject);
begin
  MyCAD1.Snap:=not MyCAD1.Snap;
end;

procedure TMainForm.SnapToShapeExecute(Sender: TObject);
begin
  MyCAD1.SnapShape:=not MyCAD1.SnapShape;
end;

procedure TMainForm.ZoominExecute(Sender: TObject);
begin
  if  MyCAD1.Zoom*2 < 100 then
  begin
    MyCAD1.Zoom:= MyCAD1.Zoom * 2;
    cmbZoom.Text:= inttostr(Round(MyCAD1.Zoom*100))+'%';
    CenterCAD;
  end;
end;

procedure TMainForm.ZoomoutExecute(Sender: TObject);
begin
  if MyCAD1.Zoom/2 > 0.01 then
  begin
    MyCAD1.Zoom:= MyCAD1.Zoom / 2;
    //showmessage(inttostr(Round(MyCAD1.Zoom*100))+'%');
    cmbZoom.Text:= inttostr(Round(MyCAD1.Zoom*100))+'%';
    CenterCAD;
  end;
end;

procedure TMainForm.NicefitExecute(Sender: TObject);
var
  zw,zh:double;
begin
  zw:=ScrollBox1.Width/(MyCAD1.Width/MyCAD1.Zoom);
  zh:=ScrollBox1.Height/(MyCAD1.Height/MyCAD1.Zoom);
  if zw < zh then
    MyCAD1.Zoom:= zw
  else
    MyCAD1.Zoom:= zh;
  CenterCAD();
  cmbZoom.Text:= inttostr(Round(MyCAD1.Zoom*100))+'%';
end;

procedure TMainForm.ShowTCADVersionExecute(Sender: TObject);
begin
  ShowMessage('The current version is:'+MyCAD1.Version);
end;

procedure TMainForm.RefreshMenu;
begin
  tbtnDelete.Enabled:=MyCAD1.GetSelectedShapesCount>0;
  tbtnBringToFront.Enabled:=MyCAD1.GetSelectedShapesCount>0;
  tbtnSendToBack.Enabled:=MyCAD1.GetSelectedShapesCount>0;
  tbtnBringToFrontByStep.Enabled:=MyCAD1.GetSelectedShapesCount>0;
  tbtnSendToBackByStep.Enabled:=MyCAD1.GetSelectedShapesCount>0;

  tbtnGroup.Enabled:=MyCAD1.GetSelectedShapesCount > 1;
  tbtnUnGroup.Enabled:=MyCAD1.GetSelectedShapesCount = 1;

  tbtnAlignTop.Enabled:=MyCAD1.GetSelectedShapesCount > 1;
  tbtnAlignBottom.Enabled:=tbtnAlignTop.Enabled;
  tbtnAlignLeft.Enabled:=tbtnAlignTop.Enabled;
  tbtnAlignRight.Enabled:=tbtnAlignTop.Enabled;
  tbtnAlignHorizontalCenter.Enabled:=tbtnAlignTop.Enabled;
  tbtnalignVerticalCenter.Enabled:=tbtnAlignTop.Enabled;

  tbtnCopy.Enabled:=MyCAD1.GetSelectedShapesCount>0;
  tbtnCut.Enabled:=MyCAD1.GetSelectedShapesCount>0;
  tbtnPaste.Enabled:=MyCAD1.GetMemShapesCount>0;

  if MyCAD1.GetSelectedShapesCount =1 then
    tbtnLock.Enabled:=not MyCAD1.GetSelectedShape.Locked
  ELSE
    IF  MyCAD1.GetSelectedShapesCount > 1 THEN
      tbtnLock.Enabled:=true
    ELSE
      tbtnLock.Enabled:=false;

  IF  MyCAD1.GetSelectedShapesCount =1 THEN
    tbtnUnlock.Enabled:=   MyCAD1.GetSelectedShape.Locked
  ELSE
    IF  MyCAD1.GetSelectedShapesCount > 1 THEN
      tbtnUnlock.Enabled:=true
    ELSE
      tbtnUnlock.Enabled:=false;

  tbtnUndo.Enabled:=true;
  
end;

procedure TMainForm.ACopyExecute(Sender: TObject);
begin
  MyCAD1.Copy();
  RefreshMenu;
end;

procedure TMainForm.CutExecute(Sender: TObject);
begin
  ShowMessage('ddddddd');
  MyCAD1.Cut();
  RefreshMenu;
end;

procedure TMainForm.PasteExecute(Sender: TObject);
begin
  MyCAD1.Paste();
  RefreshMenu;
end;

procedure TMainForm.DeleteExecute(Sender: TObject);
begin
  MyCAD1.DeleteSelectedShapes;
  //
end;

procedure TMainForm.UndoExecute(Sender: TObject);
begin
  if MyCAD1.PopfromUndoRedoShapeList =-1 then
    tbtnUndo.Enabled:=false
  else
    tbtnUndo.Enabled:=true;
end;

procedure TMainForm.GroupShapeExecute(Sender: TObject);
begin
  MyCAD1.GroupWorkingShape;
  RefreshMenu;
  //
end;

procedure TMainForm.UngroupShapeExecute(Sender: TObject);
begin
  if MyCAD1.GetSelectedShapesCount = 1 then
    MyCAD1.UnGroupShape(MyCAD1.GetSelectedShape)
  else
    ShowMessage('No shape selected or more shapes selected!');
  RefreshMenu;
 //
end;

procedure TMainForm.SendToBackExecute(Sender: TObject);
begin
  MyCAD1.SendToBack(MyCAD1.GetSelectedShape);
  RefreshMenu;
end;

procedure TMainForm.BringToFrontExecute(Sender: TObject);
begin
  MyCAD1.BringToFront(MyCAD1.GetSelectedShape);
  RefreshMenu;
end;

procedure TMainForm.LockExecute(Sender: TObject);
var
  i:integer;
begin
  with  MyCAD1 do
  for i:=0 to High(GetSelectedShapes) do
    if GetSelectedShapes[i] <> nil then
    begin
      LockUnLockforShapes(GetSelectedShapes[i],true);
      Invalidate ;
      RefreshMenu;
    end;
end;

procedure TMainForm.UnlockExecute(Sender: TObject);
var
 i:integer;
begin
  with  MyCAD1 do
  for i:=0 to High(GetSelectedShapes) do
    if GetSelectedShapes[i] <> nil then
    begin
      LockUnLockforShapes(GetSelectedShapes[i],false);
      Invalidate ;
      RefreshMenu;
    end;
end;

procedure TMainForm.SendToBackByStepExecute(Sender: TObject);
begin
  MyCAD1.SendToBackByStep(MyCAD1.GetSelectedShape);
end;

procedure TMainForm.BringToFrontByStepExecute(Sender: TObject);
begin
  MyCAD1.BringToFrontByStep(MyCAD1.GetSelectedShape);
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
  RefreshMenu;
end;

procedure TMainForm.SelectShapeExecute(Sender: TObject);
begin
  MyCAD1.SelectShapeByCode(1);
end;

procedure TMainForm.SelectMoreShapesExecute(Sender: TObject);
begin
  MyCAD1.SelectShapeByCode(2,false);
end;

procedure TMainForm.DeSelectShapeExecute(Sender: TObject);
begin
  MyCAD1.DeSelectedAllShapesByCode;
end;

procedure TMainForm.SelectAllShapesExecute(Sender: TObject);
begin
  MyCAD1.SelectAllShapes;
  RefreshMenu;
end;

procedure TMainForm.MyCAD1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if sbtnZoomIn.Down or sbtnZoomOut.Down then
  begin
    MyCAD1.Canvas.Brush.Style:=bsClear;
    MyCAD1.Canvas.Pen.Mode:=pmXor;
    MyCAD1.Canvas.Pen.Style:=psDot ;
    MyCAD1.Canvas.Pen.Color:=clBlack;
    mOrg:=Point(x,y);
    mDes:=mOrg;
    mDown:=true;
    MyCAD1.ShapeTool:=spClose;
  end;

  if sbtnDrag.down then
  begin
    mOrg:=Point(x,y);
    mDes:=mOrg;
    mDown:=true;
    MyCAD1.ShapeTool:=spClose;
  end;

end;

procedure TMainForm.MyCAD1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if sbtnZoomIn.Down or sbtnZoomOut.Down then
  begin
    if mDown then
    begin
      MyCAD1.Canvas.Rectangle(mORg.x,mOrg.Y,mDes.x,mDes.y);
      MyCAD1.Canvas.Brush.Style:=bsClear;
      MyCAD1.Canvas.Pen.Mode:=pmXor;
      MyCAD1.Canvas.Pen.Style:=psDot;
      MyCAD1.Canvas.Pen.Color:=clRed;
      mDes.x:=x;
      mDes.y:=y;
      MyCAD1.Canvas.Rectangle(mORg.x,morg.Y,mDes.x,mDes.y);
    end;
  end
  else
    if mDown then
    begin

      If (MyCAD1.Left+MyCAD1.Width > ScrollBox1.Width) or (MyCAD1.Left<0) then
      begin
        if (x-mOrg.x) < 0 then
        begin
          if MyCAD1.Left +MyCAD1.Width > ScrollBox1.Width then
            if  MyCAD1.Left +MyCAD1.Width +(x-mOrg.x) <  ScrollBox1.Width then
              MyCAD1.Left := ScrollBox1.Width - MyCAD1.Width
            else
              MyCAD1.Left:=  MyCAD1.Left +(x-mOrg.x);
        end
        else
          if MyCAD1.Left<0 then
          begin
            if  MyCAD1.Left +(x-mOrg.x) >0 then
              MyCAD1.Left:=0
            else
              MyCAD1.Left:=  MyCAD1.Left +(x-mOrg.x);
          end;
      end;


      If (MyCAD1.Top +MyCAD1.Height > ScrollBox1.Height) or (MyCAD1.Top <0) then
      begin
        if (y-mOrg.y) < 0 then
        begin
          if MyCAD1.Top +MyCAD1.Height > ScrollBox1.Height then
            if MyCAD1.Top +MyCAD1.Height +(y-mOrg.y) <  ScrollBox1.Height then
              MyCAD1.Top := ScrollBox1.Height - MyCAD1.Height
            else
              MyCAD1.Top:=  MyCAD1.Top +(y-mOrg.y);
        end
        else
          if MyCAD1.Top<0 then
          begin
            if MyCAD1.Top +(y-mOrg.y) >0 then
              MyCAD1.Top:=0
            else
              MyCAD1.Top:=  MyCAD1.Top +(y-mOrg.y);
          end;
      end;

    end;

end;

procedure TMainForm.MyCAD1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
 l:integer;
begin
  if sbtnZoomIn.Down then
  begin
    mDown:= false;
    x:= mOrg.x +( x -mOrg.x )div 2 ;
    y:= mOrg.y +( y -mOrg.y )div 2 ;
    MyCAD1.Zoom:=MyCAD1.Zoom * 1.2;
    if MyCAD1.Width <=ScrollBox1.Width then
      Mycad1.Left := (ScrollBox1.Width - MyCAD1.Width) div 2
    else
    begin
      L:= round(ScrollBox1.Width / 2  -x *1.2);
      if L > 0 then
        MyCAD1.Left:=0
      else
        MyCAD1.Left:= L;
    end;

    if MyCAD1.Height <=ScrollBox1.Height then
      MyCAD1.Top := (ScrollBox1.Height - MyCAD1.Height) div 2
    else
    begin
      L:= round(ScrollBox1.Height / 2  -y *1.2);
      if L > 0 then
        MyCAD1.Top:=0
      else
        MyCAD1.Top:= L;
    end;
    cmbZoom.Text:= inttostr(Round(MyCAD1.Zoom*100))+'%';
  end;

  if sbtnZoomOut.Down then
  begin
    mDown:= false;
    MyCAD1.Zoom:=MyCAD1.Zoom * 0.8;
    if MyCAD1.Width <=ScrollBox1.Width then
      Mycad1.Left := (ScrollBox1.Width - MyCAD1.Width) div 2
    else
    begin
      L:= round(ScrollBox1.Width / 2  -x *0.8);
      if L > 0 then
        MyCAD1.Left:=0
      else
        MyCAD1.Left:= L;
    end;

    if MyCAD1.Height <=ScrollBox1.Height then
      Mycad1.Top := (ScrollBox1.Height - MyCAD1.Height) div 2
    else
    begin
      L:= round(ScrollBox1.Height / 2  -y *0.8);
      if L > 0 then
        MyCAD1.Top:=0
      else
        MyCAD1.Top:= L;
    end;
    cmbZoom.Text:= inttostr(Round(MyCAD1.Zoom*100))+'%';
  end;


  if sbtnDrag.Down then
  begin
    mDown:=false;
  end;

  RefreshMenu;
  //
end;

procedure TMainForm.sbtnSelectingClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=SpSelecting;
end;

procedure TMainForm.MyCAD1ShapeSelected(LastSelectedShape,
  SelectedShape: TMyShape);
var
  bStyle:TBrushStyle;
  pStyle:TPenStyle;
  i:integer;

  SPenWidth:Integer;

begin
  {
  CADInspFrm.ComponentInspector1.Root:=SelectedShape  ;
  CADInspFrm.ComponentInspector1.Instance:=SelectedShape;
  }

  SPenWidth:=sePenWidth.Value;

  { Load selected shape parameter }
  PPenColor.Color:=SelectedShape.Pen.Color;
  sePenWidth.Value:=SelectedShape.Pen.Width;
  pStyle:=SelectedShape.Pen.Style;
  for i:=0 to 5 do
    if Integer(pStyle)=i then
      cmbPenStyle.ItemIndex:=i;

  PBrushColor.Color:=SelectedShape.Brush.Color;
  bStyle:=SelectedShape.Brush.Style;
  for i:=0 to 7 do
    if Integer(bStyle)=i then
      cmbBrushStyle.ItemIndex:=i;

  edtAngle.Text:=FloatToStr(SelectedShape.Angle);

  if LastSelectedShape<>nil then
    LastSelectedShape.Pen.Width:=SPenWidth
  else
    MyCAD1.Pen.Width:=SPenWidth;

  //Hide some forms.
  PLine.Visible:=false;
  PRuleLine.Visible:=false;
  PLinkLine.Visible:=false;
  PElliArc.Visible:=false;
  PImage.Visible:=false;
  PText.Visible:=false;

  if (SelectedShape is TMyLine) and (not (SelectedShape is TMyPolygon)) then
  begin

    PLine.Visible:=True;
    edtArrowAngle.Text:=floattostr(TMyLine(SelectedShape).ArrowAngle);
    edtArrowLength.Text:=floattostr(TMyLine(SelectedShape).ArrowLength);
    edtArrowOffset.Text:=floattostr(TMyLine(SelectedShape).ArrowOffset);
    for i:=0 to 3 do
      if Integer(TMyLine(SelectedShape).ArrowStyle)=i then
        cmbArrowStyle.ItemIndex:=i;

    if (SelectedShape is TMyRuleLine) then
    begin
      PRuleLine.Visible:=true;
      PRuleLine.Left:=0;
      PRuleLine.Top:=152;

      for i:=0 to 1 do
        if Integer(TMyRuleLine(SelectedShape).TickStyle)=i then
          cmbTickStyle.ItemIndex:=i;
    end;

    if (SelectedShape is TMyLinkLine) then
    begin
      PRuleLine.Visible:=false;
      PLinkLine.Visible:=true;
      PLinkLine.Left:=0;
      PLinkLine.Top:=152;

      for i:=0 to 1 do
        if Integer(TMyLinkLine(SelectedShape).LinkLineDrawStyle)=i then
          cmbLinkLineDrawStyle.ItemIndex:=i;
    end;

  end;

  if (SelectedShape is TMyElliArc) then
  begin

    PElliArc.Visible:=true;
    PElliArc.Left:=0;
    PElliArc.Top:=8;

    for i:=0 to 1 do
      if Integer(TMyElliArc(SelectedShape).ArcMode)=i then
        cmbArcMode.ItemIndex:=i;

    for i:=0 to 2 do
      if Integer(TMyElliArc(SelectedShape).ArcStyle)=i then
        cmbArcStyle.ItemIndex:=i;

  end;

  if (SelectedShape is TMyImage) then
  begin

    PImage.Visible:=true;
    PImage.Left:=0;
    PImage.Top:=8;

    cbBorder.Checked:=TMyImage(SelectedShape).Border;

  end;

  if (SelectedShape is TMyText) then
  begin

    PText.Visible:=true;
    PText.Left:=0;
    PText.Top:=8;

    edtFontSize.Text:=IntToStr(TMyText(SelectedShape).Font.Size);

    Memo1.Lines.Assign(TMyText(SelectedShape).Lines);

    for i:=0 to 2 do
      if Integer(TMyText(SelectedShape).HAlignment)=i then
        cbHAlignment.ItemIndex:=i;

    for i:=0 to 2 do
      if Integer(TMyText(SelectedShape).VAlignment)=i then
        cbVAlignment.ItemIndex:=i;

    if TMyText(SelectedShape).WordWrap=true then
      cbWordWrap.ItemIndex:=0
    else
      cbWordWrap.ItemIndex:=1;


  end;


end;

procedure TMainForm.MyCAD1ShapeAdded(var AShape: TMyShape;
  ShapeCount: Integer);
var
  bStyle:TBrushStyle;
  pStyle:TPenStyle;
  i:integer;
begin

  //MyCAD1.ReleaseCursorClipArea;

  if AShape <> nil then
    if AShape.ClassName = 'TMyImage' then
      if ImageFileOpen.Execute then
        MyCAD1.SetMyImage(AShape.ShapeId, LoadGraphicsFile(ImageFileOpen.FileName)) ;

  {if (Assigned (CADInspFrm)) and (AShape <> nil)  then
  begin
  CADInspFrm.ComponentInspector1.Root:= AShape;
  CADInspFrm.ComponentInspector1.Instance:=AShape;
  end;}



  //SPenWidth:Integer;



  //SPenWidth:=sePenWidth.Value;


  { Load selected shape parameter }
  PPenColor.Color:=AShape.Pen.Color;
  sePenWidth.Value:=AShape.Pen.Width;
  pStyle:=AShape.Pen.Style;
  for i:=0 to 5 do
    if Integer(pStyle)=i then
      cmbPenStyle.ItemIndex:=i;

  PBrushColor.Color:=AShape.Brush.Color;
  bStyle:=AShape.Brush.Style;
  for i:=0 to 7 do
    if Integer(bStyle)=i then
      cmbBrushStyle.ItemIndex:=i;

  edtAngle.Text:=FloatToStr(AShape.Angle);

  {//Hide some forms.
  PRuleLine.Visible:=false;
  PLinkLine.Visible:=false;


  if (AShape is TMyLine) and (not (AShape is TMyPolygon)) then
  begin
    pcShapes.ActivePage:=tsLine;
    //edtAngle.Text:=floattostr(AShape.Angle);
    edtArrowAngle.Text:=floattostr(TMyLine(AShape).ArrowAngle);
    edtArrowLength.Text:=floattostr(TMyLine(AShape).ArrowLength);
    edtArrowOffset.Text:=floattostr(TMyLine(AShape).ArrowOffset);
    for i:=0 to 3 do
      if Integer(TMyLine(AShape).ArrowStyle)=i then
        cmbArrowStyle.ItemIndex:=i;

    if (AShape is TMyRuleLine) then
    begin
      PRuleLine.Visible:=true;
      PRuleLine.Left:=0;
      PRuleLine.Top:=152;

      PLinkLine.Visible:=false;

      for i:=0 to 1 do
        if Integer(TMyRuleLine(AShape).TickStyle)=i then
          cmbTickStyle.ItemIndex:=i;
    end;

    if (AShape is TMyLinkLine) then
    begin
      PLinkLine.Visible:=true;
      PLinkLine.Left:=0;
      PLinkLine.Top:=152;

      PRuleLine.Visible:=false;

      for i:=0 to 1 do
        if Integer(TMyLinkLine(AShape).LinkLineDrawStyle)=i then
          cmbLinkLineDrawStyle.ItemIndex:=i;
    end;

  end;

  if (AShape is TMyElliArc) then
  begin

    pcShapes.ActivePage:=tsElliArc;

    for i:=0 to 1 do
      if Integer(TMyElliArc(AShape).ArcMode)=i then
        cmbArcMode.ItemIndex:=i;

    for i:=0 to 2 do
      if Integer(TMyElliArc(AShape).ArcStyle)=i then
        cmbArcStyle.ItemIndex:=i;

  end;

  PImage.Visible:=false;
  PText.Visible:=false;

  if (AShape is TMyImage) then
  begin
    pcShapes.ActivePage:=tsRegion;
    PImage.Visible:=true;
    PImage.Left:=0;
    PImage.Top:=8;
    PText.Visible:=false;

    cbBorder.Checked:=TMyImage(AShape).Border;

  end;

  if (AShape is TMyText) then
  begin
    pcShapes.ActivePage:=tsRegion;
    PImage.Visible:=false;
    PText.Visible:=true;
    PText.Left:=0;
    PText.Top:=8;

    edtFontSize.Text:=IntToStr(TMyText(AShape).Font.Size);

  end;}
  //Hide some forms.
  PLine.Visible:=false;
  PRuleLine.Visible:=false;
  PLinkLine.Visible:=false;
  PElliArc.Visible:=false;
  PImage.Visible:=false;
  PText.Visible:=false;

  if (AShape is TMyLine) and (not (AShape is TMyPolygon)) then
  begin

    PLine.Visible:=True;
    edtArrowAngle.Text:=floattostr(TMyLine(AShape).ArrowAngle);
    edtArrowLength.Text:=floattostr(TMyLine(AShape).ArrowLength);
    edtArrowOffset.Text:=floattostr(TMyLine(AShape).ArrowOffset);
    for i:=0 to 3 do
      if Integer(TMyLine(AShape).ArrowStyle)=i then
        cmbArrowStyle.ItemIndex:=i;

    if (AShape is TMyRuleLine) then
    begin
      PRuleLine.Visible:=true;
      PRuleLine.Left:=0;
      PRuleLine.Top:=152;

      for i:=0 to 1 do
        if Integer(TMyRuleLine(AShape).TickStyle)=i then
          cmbTickStyle.ItemIndex:=i;
    end;

    if (AShape is TMyLinkLine) then
    begin
      PRuleLine.Visible:=false;
      PLinkLine.Visible:=true;
      PLinkLine.Left:=0;
      PLinkLine.Top:=152;

      for i:=0 to 1 do
        if Integer(TMyLinkLine(AShape).LinkLineDrawStyle)=i then
          cmbLinkLineDrawStyle.ItemIndex:=i;
    end;

  end;

  if (AShape is TMyElliArc) then
  begin

    PElliArc.Visible:=true;
    PElliArc.Left:=0;
    PElliArc.Top:=8;

    for i:=0 to 1 do
      if Integer(TMyElliArc(AShape).ArcMode)=i then
        cmbArcMode.ItemIndex:=i;

    for i:=0 to 2 do
      if Integer(TMyElliArc(AShape).ArcStyle)=i then
        cmbArcStyle.ItemIndex:=i;

  end;

  if (AShape is TMyImage) then
  begin

    PImage.Visible:=true;
    PImage.Left:=0;
    PImage.Top:=8;

    cbBorder.Checked:=TMyImage(AShape).Border;

  end;

  if (AShape is TMyText) then
  begin

    PText.Visible:=true;
    PText.Left:=0;
    PText.Top:=8;

    edtFontSize.Text:=IntToStr(TMyText(AShape).Font.Size);

    for i:=0 to 2 do
      if Integer(TMyText(AShape).HAlignment)=i then
        cbHAlignment.ItemIndex:=i;

    for i:=0 to 2 do
      if Integer(TMyText(AShape).VAlignment)=i then
        cbVAlignment.ItemIndex:=i;

    if TMyText(AShape).WordWrap=true then
      cbWordWrap.ItemIndex:=0
    else
      cbWordWrap.ItemIndex:=1;
      
  end;



end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if MyCAD1.GetSelectedShape<>nil then
    case Key of
    Key_left:MyCAD1.Move(MyCAD1.GetSelectedShape,-1,0);
    Key_right:MyCAD1.Move(MyCAD1.GetSelectedShape,1,0);
    Key_up:MyCAD1.Move(MyCAD1.GetSelectedShape,0,-1);
    Key_down:MyCAD1.Move(MyCAD1.GetSelectedShape,0,1);
    end;
end;

procedure TMainForm.AExitExecute(Sender: TObject);
begin
  Close;
  Application.Terminate;
end;

procedure TMainForm.PageSetupExecute(Sender: TObject);

begin
    SetupForm.ShowModal;
end;

procedure TMainForm.PrintExecute(Sender: TObject);
begin
  MyCAD1.PrintPreview([],PreviewForm.Image1.Picture.Bitmap);

  PreviewForm.theScale:=1.0;
  PreviewForm.AdjustPosition;
  PreviewForm.ShowModal;
end;

procedure TMainForm.Splitter1Moved(Sender: TObject);
begin
  CenterCAD;
end;

procedure TMainForm.Refreshit;
var
 i,id:integer;
 SelectedNode,ANode:TTreeNode;
begin

 tvLayer.Items.Clear;
 with  MyCAD1 do
 begin
  for i := 0 to MyCAD1.GetLayersCount - 1 do
  begin
    Id := MyCAD1.GetLayerIdByNo(i);
    if Id > -1 then
    begin

      ANode := tvLayer.Items.Add(nil, GetLayerNameByID(id));

      if MyCAD1.IsVisibleLayerByID(Id) then
      begin
        ANode.ImageIndex:=0;
        ANode.SelectedIndex:=0;
      end
      else begin
        ANode.ImageIndex:=1;
        ANode.SelectedIndex:=1;
      end;

      if CurrentLayerId = id then
      begin
       SelectedNode:= ANode;
       tvLayer.Selected := SelectedNode;
      end;

    end;
  end;
 end;
end;

procedure TMainForm.sbtnLayerRefreshClick(Sender: TObject);
begin
  Refreshit;
end;

procedure TMainForm.sbtnLayerNewClick(Sender: TObject);
begin
  MyCAD1.NewLayer('Layer' + inttostr(MyCAD1.GetMaxLayerId + 1));
  Refreshit;
end;

procedure TMainForm.sbtnLayerDeleteClick(Sender: TObject);
var
  id: integer;
begin
  Screen.Cursor:= crHourGlass;
  if tvLayer.Selected.Index > -1 then
  begin
    Id :=MyCAD1.GetLayerIdByNo(tvLayer.Selected.Index);
    MyCAD1.DeleteLayerByID(id);
    Refreshit;
  end;
  Screen.Cursor:= crDefault;
end;

procedure TMainForm.sbtnLayerHideVisibleClick(Sender: TObject);
var
 id:integer;
begin
 with MyCAD1  do
 begin
  id:= GetLayerIdByNo(tvLayer.Selected.Index);
  if id > -1 then
  Begin
    if IsVisibleLayerByID(id) then
      InVisibleLayerById(id)
    else
      VisibleLayerById(id);
    Refreshit;
  end;
 end;
end;

procedure TMainForm.tvLayerEdited(Sender: TObject; Node: TTreeNode;
  var S: WideString);
begin
  if s='' then s:=Node.Text;
  MyCAD1.SetLayerNameByName(s,Node.Text);
end;

procedure TMainForm.tvLayerChange(Sender: TObject; Node: TTreeNode);
begin
  MyCAD1.CurrentLayerId:= MyCAD1.GetLayerIdByNo(Node.Index);
end;

procedure TMainForm.NewExecute(Sender: TObject);
begin
  if MessageDlg('Begin a new drawing?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
    if  SaveEditingFile  then
    begin
      MyCAD1.ClearAllUndoStuff ;
      MyCAD1.DeleteAllShapes;
      MyCAD1.Global_Changed:=false;
    end;
  end;
end;

function TMainForm.SaveEditingFile: boolean;
var
  AWord:Word;
begin
  result:=true;
  IF MyCAD1.Global_Changed THEN
  BEGIN

    AWord:= MessageDlg('File ['+EditingFileName+ '] has changed, do you want to save it?',  mtConfirmation, [mbYes, mbNo,mbCancel], 0);

    IF  AWord = mrYes then
    begin
      IF EditingFileName='NoName.TCAD' THEN
      begin
        FileSaveAs.InitialDir:=ExtractFilePath(Application.ExeName);
        if FileSaveAs.Execute then
          if MyCAD1.SaveToFile(FileSaveAs.FileName) then
            ShowMessage('MyCAD1 has been saved to '+FileSaveAs.FileName);
      end
      else
        if MyCAD1.SaveToFile(EditingFileName) then
           ShowMessage('MyCAD1 has been saved to '+EditingFileName);

      ShowMessage('true');
      result:= true;

    END;

    IF  AWord = mrNo then result:= true;

    IF  AWord = mrCancel then result:= false;

  end;

end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  EditingFileName:='NoName.TCAD';
  MyCAD1.Brush.Style:=bsClear;
end;

procedure TMainForm.OpenExecute(Sender: TObject);
begin
  FileOpen.Filter:='TCAD drawing file (*.tcad)|*.tcad';
  FileOpen.FilterIndex:=1;
  FileOpen.InitialDir:=ExtractFilePath(Application.ExeName);

  if MyCAD1.Global_Changed then
    if not SaveEditingFile then
      exit;

  if FileOpen.Execute then
  begin
    if MyCAD1.IsTCADFile(FileOpen.FileName) then
    begin
      MyCAD1.DeleteAllShapes;
      if not MyCAD1.LoadFromFile(FileOpen.FileName) then
        ShowMessage('Error when read file')
      else
      begin
        cmbZoom.ItemIndex :=2;
        CenterCAD;
        Refreshit;
        EditingFileName:= FileOpen.FileName;
      end;
    end
    else
      ShowMessage(FileOpen.FileName + 'is not a TCAD format file');

  end;

end;

procedure TMainForm.OpenLibExecute(Sender: TObject);
begin
  FileOpen.Filter:='TCAD library file(*.lib)|*.lib';
  FileOpen.FilterIndex:=1;
  FileOpen.InitialDir:=ExtractFilePath(Application.ExeName);

  if FileOpen.Execute then
  begin
    if FileExists(FileOpen.FileName) then
    begin
      LoadLib(FileOpen.FileName);
      PageControl1.ActivePage:=tsLibrary;
    end;
  end;

end;

procedure TMainForm.ImportTCADFileExecute(Sender: TObject);
begin
  FileOpen.Filter:='TCAD drawing file(*.tcad)|*.tcad';
  FileOpen.FilterIndex:=1;
  FileOpen.InitialDir:=ExtractFilePath(Application.ExeName);

  if FileOpen.Execute then
    if FileExists(FileOpen.FileName) then
      MyCAD1.AddBlockfromTCADFile(FileOpen.FileName,Append);

end;

procedure TMainForm.DrawListView(LibFileName: string);
begin
//
end;

procedure TMainForm.LoadLib(LibFileName: String);
var
  i:integer;
  ABitmap:TBitmap;
  AListItem: TListItem;
  AlibImageList:TImageList;
  mCaption:string;
begin
  if IsTCADLibFile(LibFileName) then
  begin

    for i:=0 to High(LibManagers) do
    begin
      if Pos(LibManagers[High(LibManagers)].LibFileName,LibFileName ) > 0 then
      begin
        ShowMessage('This Lib: '+ LibFileName +' has been opened!');
        exit;
      end;
    end;


    SetLength(LibManagers,High(LibManagers)+2);
    LibManagers[High(LibManagers)]:=TLibManager.Create;
    LibManagers[High(LibManagers)].LoadFromFile(LibFileName);
    mLibManager:=   LibManagers[High(LibManagers)];

    ATabSheet:=TTabSheet.Create( PageControl2);
    ATabSheet.Parent:= PageControl2;
    ATabSheet.PageControl:=PageControl2;
    LibFileName:=ExtractFileName(LibFileName);
    ATabSheet.Caption:=copy(LibFileName,0,pos('.',LibFileName)-1);
    ATabSheet.OnShow:=TabSheetShow;
    PageControl2.ActivePage:=ATabSheet;




    AlibImageList:=TImageList.Create(ATabSheet);
    AlibImageList.Height := 32;
    AlibImageList.Width  := 32;
    ABitmap:=TBitmap.Create;
    For i:=0 to mLibManager.cmbShapesCount -1  do
    begin
      mCaption:=mLibManager.GetCmbShapesNameByID(i);
      If  ord(mCaption[1])  >123 then ATabSheet.Font.Name:='';
      mLibManager.GetCmbShapeimage(mCaption, AlibImageList.Width,ABitmap,ClGray);
                                   AlibImageList.Add(ABitmap,nil);

    end;
    ABitmap.Free;

   AListView:=TListView.Create(ATabSheet);
   AListView.Parent:=ATabSheet;
   AListView.Align:=alClient;
   //AListView.ViewStyle:=  vsIcon;
   AListView.ViewStyle:=vsList;
   //AListView.IconOptions.AutoArrange:=true;
   //AListView.LargeImages:= AlibImageList;
   AListView.Images:=ALibImageList;
   AListView.Color:=ClGray;
   AListView.DragMode :=dmAutomatic;
  //AListView.Clear  ;
  For i:=0 to mLibManager.cmbShapesCount -1  do
    begin
    AListItem:=AListView.Items.Add;
    mCaption:=  mLibManager.GetCmbShapesNameByID(i);
    AListItem.Caption:=mCaption;
    AListItem.ImageIndex:=i;
   end;


    mListView:=AListView;

  end;

end;

procedure TMainForm.RemoveLibManager(id: integer);
var
  i:integer;
begin
  LibManagers[Id].Free;
  for i:=id to High(LibManagers)-1 do
    LibManagers[i]:= LibManagers[i+1];
  SetLength(LibManagers,High(LibManagers))
end;

procedure TMainForm.TabSheetShow(Sender: TObject);
var
  i:integer;        
begin

  if  (Sender As TTabSheet).ComponentCount = 2 then
  begin
    for i:=0 to High(LibManagers) do
      if Pos((Sender As TTabSheet).Caption, LibManagers[i].LibFileName)>0 then
      begin
        mLibManager :=  LibManagers[i];
        mListView:=(Sender As TTabSheet).Components[1] as TListView;
      end;
  end;

end;

procedure TMainForm.FormDestroy(Sender: TObject);
var
  i:integer;
begin
  for i:= 0 to High(LibManagers) do
    LibManagers[i].Free;
end;

procedure TMainForm.miCloseClick(Sender: TObject);
var
 id,i:integer;
begin

  id:=-1;
  for i:=0 to High(LibManagers) do
    if pos(PageControl2.ActivePage.Caption, LibManagers[i].LibFileName) >0 then
      id:=i;

  if Id > -1 then RemoveLibManager(id);
  if PageControl2.ActivePage <> nil then  PageControl2.ActivePage.Free;
end;

procedure TMainForm.MyCAD1DragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  if Source is TListView then
  begin
    mListView:=   Source as TListView ;
    MyCAD1.AddUserDefineShapefromLib(mLibManager,mListView.Selected.Caption,X,Y,MyCAD1);
    RefreshMenu;
  end;
end;

procedure TMainForm.MyCAD1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept:=Source is TListView;
end;

procedure TMainForm.LayerManagerExecute(Sender: TObject);
begin
  PageControl1.ActivePage:=tsLayer;
end;

procedure TMainForm.LibraryManagerExecute(Sender: TObject);
begin
  PageControl1.ActivePage:=tsLibrary;
end;

procedure TMainForm.BitmapExecute(Sender: TObject);
begin
  FileExport.Filter:='Bitmap file(*.bmp)|*.bmp';
  FileExport.FilterIndex:=1;
  FileExport.InitialDir:=ExtractFilePath(Application.ExeName);

  if FileExport.Execute then
  begin
    MyCAD1.SaveToBmp(FileExport.FileName);
    ShowMessage('MyCAD1 has been saved to '+ FileExport.FileName);
  end;

end;

procedure TMainForm.SelectingExecute(Sender: TObject);
begin
  MyCAD1.ShapeTool:=SpSelecting;
end;

procedure TMainForm.LineExecute(Sender: TObject);
begin
  if MyCAD1.GetShapeByName('LineShape') = nil then
  begin
    ShowMessage('MyCAD1.AddShapeByCode(MyCAD1,spLine, ''LineShape'', [MyPoint(13, 4), MyPoint(40, 50)]);');
    MyCAD1.AddShapeByCode(MyCAD1,spLine, 'LineShape', [MyPoint(13, 4), MyPoint(40, 50)]);
  end;
end;

procedure TMainForm.RuleLineExecute(Sender: TObject);
begin
  if MyCAD1.GetShapeByName('RuleLineShape') = nil then
  Begin
    ShowMessage('MyCAD1.AddShapeByCode(MyCAD1,spRuleLine, ''RuleLineShape'', [MyPoint(131, 41), MyPoint(140,150)]);');
    MyCAD1.AddShapeByCode(MyCAD1,spRuleLine, 'RuleLineShape', [MyPoint(131, 41), MyPoint(140,150)]);
  end;
end;

procedure TMainForm.ArcExecute(Sender: TObject);
{var
  AShapeId:integer;}
begin
  if MyCAD1.GetShapeByName('ArcShape') = nil then
  begin
    ShowMessage('AShapeId:=MyCAD1.AddShapeByCode(MyCAD1,spElliArc, ''ArcShape'', [MyPoint(330, 211),  MyPoint(380, 211), MyPoint(380, 270)], 0);');
    //AShapeId:=MyCAD1.AddShapeByCode(MyCAD1,spElliArc, 'ArcShape', [MyPoint(330, 211),  MyPoint(380, 211), MyPoint(380, 270)], 0);
    MyCAD1.AddShapeByCode(MyCAD1,spElliArc, 'ArcShape', [MyPoint(330, 211),  MyPoint(380, 211), MyPoint(380, 270)], 0);
  end;
end;

procedure TMainForm.PolyLineExecute(Sender: TObject);
begin
  if MyCAD1.GetShapeByName('PolyLineShape') = nil then
  begin
    ShowMessage('MyCAD1.AddShapeByCode(MyCAD1,spPolyLine, ''PolyLineShape'', [MyPoint(90, 11), MyPoint(80,70), MyPoint(110, 120), MyPoint(10, 120)]);');
    MyCAD1.AddShapeByCode(MyCAD1,spPolyLine, 'PolyLineShape', [MyPoint(90, 11), MyPoint(80,70), MyPoint(110, 120), MyPoint(10, 120)]);
  end;
end;

procedure TMainForm.PolygonExecute(Sender: TObject);
var
  p: array of TmyPoint;
begin
  SetLength(P, 4);
  P[0] := MyPoint(390, 11);
  p[1] := MyPoint(380, 70);
  p[2] := MyPoint(210, 10);
  p[3] := MyPoint(110, 190);
  if MyCAD1.GetShapeByName('PolygonShapeArray') = nil then
  begin
    ShowMessage('MyCAD1.AddShapeByCode(MyCAD1,spPolygon, ''PolygonShapeArray'', p);{ p is a array}');
    MyCAD1.AddShapeByCode(MyCAD1,spPolygon, 'PolygonShapeArray', p);
  end;
  SetLength(P, 0);
end;

procedure TMainForm.PolyBezierExecute(Sender: TObject);
begin
//
end;

procedure TMainForm.RectangleExecute(Sender: TObject);
begin
  if MyCAD1.GetShapeByName('RectangleShape') = nil then
  begin
    ShowMessage('MyCAD1.AddShapeByCode(MyCAD1,spRectangle, ''RectangleShape'', [MyPoint(290, 211),MyPoint(380, 211), MyPoint(380, 270), MyPoint(290, 270)], 30 * pi / 180);');
    MyCAD1.AddShapeByCode(MyCAD1,spRectangle, 'RectangleShape', [MyPoint(290, 211),MyPoint(380, 211), MyPoint(380, 270), MyPoint(290, 270)], 30 * pi / 180);
  end;
end;

procedure TMainForm.EllipseExecute(Sender: TObject);
begin
  if MyCAD1.GetShapeByName('EllipseShape') = nil then
  begin
    ShowMessage('MyCAD1.AddShapeByCode(MyCAD1,spEllipse,''EllipseShape'',[MyPoint(380, 261), MyPoint(430,261) ,MyPoint(430, 320),MyPoint(380,320)]);');
    MyCAD1.AddShapeByCode(MyCAD1,spEllipse,'EllipseShape',[MyPoint(380, 261), MyPoint(430,261) ,MyPoint(430, 320),MyPoint(380,320)]);
  end;
end;

procedure TMainForm.TextExecute(Sender: TObject);
begin
//
end;

procedure TMainForm.sbtnTextClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=SpText;
end;

procedure TMainForm.sePenWidthChanged(Sender: TObject; NewValue: Integer);
begin
  if MyCAD1.GetSelectedShape<>nil then
    MyCAD1.GetSelectedShape.Pen.Width:=sePenWidth.Value
  else
    MyCAD1.Pen.Width:=sePenWidth.Value;
  MyCAD1.Repaint;
end;

procedure TMainForm.LoadCommonParameter;
var
  pStyle:TPenStyle;
  bStyle:TBrushStyle;
  i:integer;
begin

  //Get current parameter.
  PPenColor.Color:=MyCAD1.Pen.Color;
  sePenWidth.Value:=MyCAD1.Pen.Width;
  //Get current PenStyle.
  pStyle:=MyCAD1.Pen.Style;
  for i:=0 to 5 do
    if Integer(pStyle)=i then
      cmbPenStyle.ItemIndex:=i;

  //Get current parameter.
  PBrushColor.Color:=MyCAD1.Brush.Color;
  //Get current PenStyle.
  bStyle:=MyCAD1.Brush.Style;
  for i:=0 to 7 do
    if Integer(bStyle)=i then
      cmbBrushStyle.ItemIndex:=i;
end;

procedure TMainForm.cmbPenStyleChange(Sender: TObject);
begin
  if MyCAD1.GetSelectedShape<>nil then
    MyCAD1.GetSelectedShape.Pen.Style:=TPenStyle(cmbPenStyle.ItemIndex)
  else
    MyCAD1.Pen.Style:=TPenStyle(cmbPenStyle.ItemIndex);
  MyCAD1.Repaint;
end;

procedure TMainForm.PPenColorClick(Sender: TObject);
begin
  if ColorDialog1.Execute then
    if MyCAD1.GetSelectedShape <> nil then
    begin
      MyCAD1.GetSelectedShape.Pen.Color:=ColorDialog1.Color;
      PPenColor.Color:=ColorDialog1.Color;
      MyCAD1.Repaint;
    end
    else
      MyCAD1.Pen.Color:=ColorDialog1.Color;

end;

procedure TMainForm.PBrushColorClick(Sender: TObject);
begin
  if ColorDialog1.Execute then
    if MyCAD1.GetSelectedShape <> nil then
    begin
      MyCAD1.GetSelectedShape.Brush.Color:=ColorDialog1.Color;
      PBrushColor.Color:=ColorDialog1.Color;
      MyCAD1.Repaint;
    end
    else
      MyCAD1.Brush.Color:=ColorDialog1.Color;
end;

procedure TMainForm.edtArrowAngleKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key=4100 then
    if MyCAD1.GetSelectedShape is TMyLine then
    begin
      TMyLine(MyCAD1.GetSelectedShape).ArrowAngle:=StrToInt(edtArrowAngle.Text);
      MyCAD1.Repaint;
    end;
end;

procedure TMainForm.edtArrowLengthKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if MyCAD1.GetSelectedShape is TMyLine then
    if Key=4100 then
    begin
      TMyLine(MyCAD1.GetSelectedShape).ArrowLength:=StrToInt(edtArrowLength.Text);
      MyCAD1.Repaint;
    end;
end;

procedure TMainForm.edtArrowOffsetKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if MyCAD1.GetSelectedShape is TMyLine then
    if Key=4100 then
    begin
      TMyLine(MyCAD1.GetSelectedShape).ArrowOffset:=StrToInt(edtArrowOffset.Text);
      MyCAD1.Repaint;
    end;
end;

procedure TMainForm.cmbArrowStyleChange(Sender: TObject);
begin
  if MyCAD1.GetSelectedShape is TMyLine then
  begin
    TMyLine(MyCAD1.GetSelectedShape).ArrowStyle:=TArrowStyle(cmbArrowStyle.ItemIndex);
    MyCAD1.Repaint;
  end;
end;

procedure TMainForm.cmbBrushStyleChange(Sender: TObject);
begin
  if MyCAD1.GetSelectedShape<>nil then
    MyCAD1.GetSelectedShape.Brush.Style:=TBrushStyle(cmbBrushStyle.ItemIndex)
  else
    MyCAD1.Brush.Style:=TBrushStyle(cmbBrushStyle.ItemIndex);
  MyCAD1.Repaint;
end;

procedure TMainForm.cmbTickStyleChange(Sender: TObject);
begin
  if MyCAD1.GetSelectedShape is TMyRuleLine then
  begin
    TMyRuleLine(MyCAD1.GetSelectedShape).TickStyle:=TTickStyle(cmbTickStyle.ItemIndex);
    MyCAD1.Repaint;
  end;
end;

procedure TMainForm.cmbLinkLineDrawStyleChange(Sender: TObject);
begin
  if MyCAD1.GetSelectedShape is TMyLinkLine then
  begin
    TMyLinkLine(MyCAD1.GetSelectedShape).LinkLineDrawStyle:=TLinkLineDrawStyle(cmbLinkLineDrawStyle.ItemIndex);
    MyCAD1.Repaint;
  end;
end;

procedure TMainForm.cmbArcModeChange(Sender: TObject);
begin
  if MyCAD1.GetSelectedShape is TMyElliArc then
  begin
    TMyElliArc(MyCAD1.GetSelectedShape).ArcMode:=TArcMode(cmbArcMode.ItemIndex);
    MyCAD1.Repaint;
  end;
end;

procedure TMainForm.cmbArcStyleChange(Sender: TObject);
begin
  if MyCAD1.GetSelectedShape is TMyElliArc then
  begin
    TMyElliArc(MyCAD1.GetSelectedShape).ArcStyle:=TArcStyle(cmbArcStyle.ItemIndex);
    MyCAD1.Repaint;
  end;
end;

procedure TMainForm.cbBorderClick(Sender: TObject);
begin
  if MyCAD1.GetSelectedShape is TMyImage then
  begin
    TMyImage(MyCAD1.GetSelectedShape).Border:= cbBorder.Checked;
    MyCAD1.Repaint;
  end;
end;

procedure TMainForm.btnSetBitmapClick(Sender: TObject);
begin
  if (MyCAD1.GetSelectedShape is TMyImage) then
    if ImageFileOpen.Execute then
      MyCAD1.SetMyImage(TMyImage(MyCAD1.GetSelectedShape).ShapeId, LoadGraphicsFile(ImageFileOpen.FileName)) ;
end;

procedure TMainForm.InspectorExecute(Sender: TObject);
begin
  PageControl1.ActivePage:=tsInspector;
end;

procedure TMainForm.edtAngleKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key=4100 then
    if MyCAD1.GetSelectedShape is TMyShape then
    begin
      MyCAD1.GetSelectedShape.Angle:=StrToFloat(edtAngle.Text);
      MyCAD1.Repaint;
    end;
end;

procedure TMainForm.MyCAD1ShapeMouseRotated(AShape: TMyShape; FromPoint,
  ToPoint: TPoint);
begin
  edtAngle.Text:=FloatToStr(AShape.Angle);
end;

procedure TMainForm.MyCAD1Click(Sender: TObject);
var
  i:integer;
begin
  if (MyCAD1.GetSelectedShape=nil) and ((MyCAD1.ShapeTool=SpSelecting) or (MyCAD1.ShapeTool=SpRotateSelecting)) then
  begin
  
    PLine.Visible:=false;
    PRuleLine.Visible:=false;
    PLinkLine.Visible:=false;
    PElliArc.Visible:=false;
    PImage.Visible:=false;
    PText.Visible:=false;

    PPenColor.Color:=MyCAD1.Pen.Color;
    sePenWidth.Value:=MyCAD1.Pen.Width;
    for i:=0 to 5 do
      if Integer(MyCAD1.Pen.Style)=i then
        cmbPenStyle.ItemIndex:=i;
    PBrushColor.Color:=MyCAD1.Brush.Color;
    for i:=0 to 7 do
      if Integer(MyCAD1.Pen.Style)=i then
        cmbBrushStyle.ItemIndex:=i;
  end;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if MyCAD1.Global_Changed then
    if not SaveEditingFile then
      CanClose:=false;
end;

procedure TMainForm.SaveAsExecute(Sender: TObject);
begin
//
end;

procedure TMainForm.edtFontSizeKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key=4100) or (Key=4101) then
    if MyCAD1.GetSelectedShape is TMyText then
    begin
      TMyText(MyCAD1.GetSelectedShape).Font.Size:=StrToInt(edtFontSize.Text);
      MyCAD1.Repaint;
    end;

  //showmessage(IntToStr(key));
end;

procedure TMainForm.cbHAlignmentChange(Sender: TObject);
begin
  if MyCAD1.GetSelectedShape is TMyText then
  begin
    TMyText(MyCAD1.GetSelectedShape).HAlignment:=TAlignment(cbHAlignment.ItemIndex);
    MyCAD1.Repaint;
  end;
end;

procedure TMainForm.cbVAlignmentChange(Sender: TObject);
begin
  if MyCAD1.GetSelectedShape is TMyText then
  begin
    TMyText(MyCAD1.GetSelectedShape).VAlignment:=TVAlignment(cbVAlignment.ItemIndex);
    MyCAD1.Repaint;
  end;
end;

procedure TMainForm.cbWordWrapChange(Sender: TObject);
begin
  if MyCAD1.GetSelectedShape is TMyText then
  begin
    if cbWordWrap.ItemIndex=0 then
      TMyText(MyCAD1.GetSelectedShape).WordWrap:=true
    else
      TMyText(MyCAD1.GetSelectedShape).WordWrap:=false;
    MyCAD1.Repaint;
  end;
end;

procedure TMainForm.btnUpdateClick(Sender: TObject);
begin
  if MyCAD1.GetSelectedShape is TMyText then
  begin
    TMyText(MyCAD1.GetSelectedShape).Lines.Assign(Memo1.Lines);
    MyCAD1.Repaint;
  end;
end;

procedure TMainForm.btnClearClick(Sender: TObject);
begin
  if MyCAD1.GetSelectedShape is TMyText then
  begin
    Memo1.Clear;
    TMyText(MyCAD1.GetSelectedShape).Lines.Clear;
    MyCAD1.Repaint;
  end;
end;

end.
